> ## Documentation Index
> Fetch the complete documentation index at: https://docs.neuro-tech.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Search in vault

## Overview

Allows the client to search for items in the vault. It is only possible to retrieve items that have been stored using the same account.

## HTTP request

`POST /Agent/Storage/SearchInVault`

## Authentication

Requires a valid JWT bearer token.

## Request (JSON)

```json theme={null}
{
	"type": Optional(Str(PType)),
	"clientId": Optional(Str(PClientId)),
	"masked": Optional(Bool(PMasked)),
	"Tags":
	{
		"name": Required(Str(PTagName)),
		"value": Required(Str(PTagValue))
	}?[],
	"offset": Optional(Integer(POffset >= 0)),
	"maxCount": Optional(Integer(0 < PMaxCount <= 100))
}
```

## Input parameters

| Parameter | Description                                                                                                                                            |
| --------- | ------------------------------------------------------------------------------------------------------------------------------------------------------ |
| PType     | An optional type string. Can be null. Returns items matching this type, if provided.                                                                   |
| PClientId | An optional Client Identifier. Can be null. Returns items matching this identifier, if provided.                                                       |
| PMasked   | If the masked information should be returned (true) or the full information (false).                                                                   |
| PTagName  | The name of the information tag. Only items containing this tag will be returned.                                                                      |
| PTagValue | The value of the information tag. Only items containing the named tag, with either the value or the masked value matching this value will be returned. |
| POffset   | Ignore the first POffset number of items found.                                                                                                        |
| PMaxCount | Maximum number of items to return.                                                                                                                     |

## Response (JSON)

```json theme={null}
{
	"ResultSet": Optional(
		{
			"vaultId": Required(Str(PVaultId)),
			"type": Optional(Str(PType)),
			"clientId": Optional(Str(PClientId)),
			"created": Required(DateTime(PCreated)),
			"updated": Required(DateTime(PUpdated)),
			"Tags":
			{
				"name": Required(Str(PName)),
				"value": Required(Str(PValue))
			}[]
		}
		[])
}
```

## Response parameters

| Parameter | Description                                                                                                              |
| --------- | ------------------------------------------------------------------------------------------------------------------------ |
| PCreated  | When the vault item was first created.                                                                                   |
| PUpdated  | When the vault item was last updated.                                                                                    |
| PType     | An optional type string. Client can define type strings to separate different types of information into different items. |
| PClientId | An optional Client Identifier used by the agent to separate sensitive information between clients it serves.             |
| PVaultId  | The identifier of the vault item.                                                                                        |
| PName     | The name of the information tag.                                                                                         |
| PValue    | The value or masked value of the information tag, depending on PMasked.                                                  |

## Notes

This endpoint uses the request schema notation described in [Pattern matching](/neuron-api/pattern-matching).
